// role.controller.js
angular
    .module('RoleModule',['ui.grid','ui.grid.selection'])
    .controller('RoleController', RoleController);


function RoleController(dataService, $uibModal) { 
	var vm=this;
	vm.titleContent = "Create Role";
	
	vm.rolesList=[];
	vm.allPrivileges=[];
	vm.roleInfo ={};
	vm.roleInfo.roleName = "AutomationExpert";
	vm.roleInfo.description = "AutomationExpert";

		function getRoles() {
        dataService.restCall('index/roles', 'GET').then(function (response) {
           //console.log(response);
		   vm.rolesList= response;
        	if(response.length != 0){
        	vm.gridOptions.data = vm.rolesList;}
        	}, function (error) {
        	console.log(error);
        });
    }	
	(function () {

        //function: get list of Roles
		getRoles();
        console.log('getrole');
       
    } ());
	vm.saveRoleDetails = function(){
		
		
		
	}
	vm.AddRoleDetails = function (titlename) {
		console.log('opening pop up Add');
		var modalInstance = $uibModal.open({
		
		  templateUrl: './resources/app/components/roles/add-edit-role.view.html',
	      controller: 'RoleModalInstanceCtrl',
	      controllerAs: 'vm',
	      resolve: {
	          items: function () {
	            return vm.itemsTOEditModel;
	          },
	          titlename: function () {
		    	  return titlename;
		    	  }
	        }
		});
		}
	
	vm.editRoleDetails = function(row,titlename){
		//alert('row data delete: '+ JSON.stringify(row));
		console.log('opening Edit pop up');
		vm.itemsTOEditModel = [row.strRoleName,row.strRoleDesc];
		var modalInstance = $uibModal.open({
		
		  templateUrl: './resources/app/components/roles/add-edit-role.view.html',
	      controller: 'RoleModalInstanceCtrl',
	      controllerAs: 'vm',
	      resolve: {
	          items: function () {
	            return vm.itemsTOEditModel;
	          },
	          titlename: function () {
		    	  return titlename;
		    	  }
	        }
		});
	}
	vm.openRoleModel=function(){
	//	vm.titleContent = "Create Role";
	//	$("#addRole").modal();
	}
	vm.displayDeleteRoleModal = function(row){
		//console.log('row data delete: '+ JSON.stringify(row));
		//$window.confirm("Do you want to delete role " + JSON.stringify(row) + "?")
		alert('row data delete: '+ JSON.stringify(row));
	}
	vm.linkButtons = 
		'<div class="ui-grid-cell-contents"><a class="CustomIconaTag" title="Edit Role"><i class="fa fa-edit iconLink" data-toggle="modal" ng-click="grid.appScope.editRoleDetails(row.entity,\'Edit Role\')"></i></a>'+
		  ' <a class="CustomIconaTag"  title="Delete Role"><i class="fa fa-trash-o iconLink" data-toggle="modal" ng-click="grid.appScope.displayDeleteRoleModal(row.entity)"></i></a>'
			+  ' <a class="CustomIconaTag"  title="Reset Password"><i class="fa fa-refresh iconLink" data-toggle="modal"></i></a></div>';
	
		vm.data = [{
		  "Name": "test0",
		  "Description": "test1",
		  "Privileges": "test2",
		}, {
	        "Name": "test3",
		  "Description": "test4",
		  "Privileges": "test5",
		}, {
		  "Name": "test6",
		  "Description": "test7",
		  "Privileges": "test8",
		}, {
		  "Name": "test9",
		  "Description": "test10",
		  "Privileges": "test12",
		}, {
		  "Name": "test13",
		  "Description": "test14",
		  "Privileges": "test15",
		}, {
		  "Name": "test16",
		  "Description": "test17",
		  "Privileges": "test18",
		}, {
		  "Name": "test19",
		  "Description": "test20",
		  "Privileges": "test21",
		}];
vm.gridOptions = {
			data:vm.data,
			enableFiltering: false,
			 enableColumnMenus: false,
			 enableRowSelection: true,
			 enableSorting: false,
			 enableSelectAll: true,
			 enableHiding: false,			 
			  onRegisterApi: function(gridApi) {
			  vm.gridApi = gridApi;
			  vm.gridApi.grid.registerRowsProcessor(vm.singleFilter, 200);
			},
		columnDefs: [ {
			  field: 'strRoleName',displayName: 'Name'},
			  {field: 'strRoleDesc',displayName: 'Description'},
			  {field: 'strPrivileges',displayName: 'Privileges'},
			  {name: 'Actions',displayName: 'Actions',cellTemplate: vm.linkButtons}
			]};
	
		vm.gridOptions.appScopeProvider = vm;
	    
	
			vm.filter = function() {
			vm.gridApi.grid.refresh();
			};
		
			vm.singleFilter = function(renderableRows) {
			var matcher = new RegExp(vm.filterValue);
			renderableRows.forEach(function(row) {
			  var match = false;
			  ['strRoleName'].forEach(function(field) {
			    
			    if (row.entity[field] && row.entity[field].match(matcher)) {
			      match = true;
			    }
			  });
			  if (!match) {
			    row.visible = false;
			  }
			});
			return renderableRows;
			};
	/*-------------------------------*/
		
}
angular.module('RoleModule').controller('RoleModalInstanceCtrl', function ($uibModalInstance,items,titlename) {
	var vm = this;
	console.log(items);
	vm.titlename = titlename;
	
	vm.roleInfo = {};
	vm.roleInfo.availablePrivileges = ['Red','Green','Blue','Yellow','Magenta'];

	vm.roleInfo.selectedPrivilege = [];
	vm.items = items;
	
	vm.roleInfo.roleName = vm.items[0];
			vm.roleInfo.description =  vm.items[1];
			vm.roleInfo.enableStatus =  vm.items[2];
			
			//vm.roleInfo.selectedPrivilege =  vm.items[3];
	  vm.cancel = function () {
	    $uibModalInstance.dismiss('cancel');
	  };
	  
	
	});
