// user.controller.js
angular
    .module('UserModule',['ui.grid','ui.grid.selection'])
    .controller('UserController', UserController);

function UserController(dataService, $uibModal) { 
	var vm=this;
	vm.titleContent = "Create User";
	
	vm.usersList=[];
	
	vm.userInfo ={};
	 vm.userAddUpdateInfo ={};
	vm.userInfo.userName = "Biju";
	vm.userInfo.password = "BijuB";
	vm.userInfo.confirmPassword = "BijuB";
	vm.userInfo.emailID = "Biju_Nair03@infosys.com";
	vm.userInfo.roles = [{"IRoleId":4,"strRoleName":"AutomationExpert","strRoleDesc":"This Role is used from ITSP as automation expert role","IEnableStatus":1},
	                             {"IRoleId":3,"strRoleName":"TestPlanner","strRoleDesc":"This Role is used from ITSP as tester role","IEnableStatus":1},
	                             {"IRoleId":2,"strRoleName":"SelfRegistered","strRoleDesc":"This Role is used for self registered users","IEnableStatus":1},
	                             {"IRoleId":1,"strRoleName":"admin","strRoleDesc":"This Role has all Privileges","IEnableStatus":1}];
		
	function getUsers() {
        dataService.restCall('index/users', 'GET').then(function (response) {
        	//console.log('response data123'+ response);
        	
        	vm.usersList= response;
        	if(response.length != 0){
        	vm.gridOptions.data = vm.usersList;
        	}
        	
        	
        	//console.log('haii'+ JSON.stringify(vm.usersList));
        }, function (error) {
        	console.log(error);
        });
    }
	
	(function () {

        //function: get list of Roles
		getUsers();
        console.log('getuser');
       // getAllRoles();
       
    } ());
	
	
	/*vm.saveUserDetails = function(){
		
		
		
	}*/
	//vm.itemsToAddModel= vm.userInfo;
	
	vm.AddUserDetails = function (itemsToAddModel,titlename) {
		console.log('opening pop up Add');
		var modalInstance = $uibModal.open({
		
		  templateUrl: './resources/app/components/users/add-edit-user.view.html',
	      controller: 'ModalInstanceCtrl',
	      controllerAs: 'vm',
	      resolve: {
	          items: function () {
	            return itemsToAddModel;
	          },
	          titlename: function () {
		    	  return titlename;
		    	  }
	        }
		});
		modalInstance.result.then(function (userInfo) {
		     vm.userAddUpdateInfo = userInfo;
		     console.log('User info in user control :'+ JSON.stringify(vm.userAddUpdateInfo));
		    }, function () {
		     // $log.info('Modal dismissed at: ' + new Date());
		    	console.log('Modal dismissed at: ' + new Date());
		    });
		}
	
	vm.editUserDetails = function(row,titlename){
		//console.log('row data edit: '+ JSON.stringify(row));
		//alert('row data edit: '+ JSON.stringify(row));
	//	vm.userInfo.userName = row.strUserName;
	//	vm.userInfo.password = row.strPassword;
	//	vm.userInfo.confirmPassword = row.strPassword;
	//	vm.userInfo.emailID = row.strEmailId;
	//	vm.titleContent = "Edit User";
	//	$("#addUser").modal();
		console.log('opening Edit pop up');
		//vm.itemsTOEditModel = [row.strUserName,row.strPassword,row.strEmailId];
		var modalInstance = $uibModal.open({
		
		  templateUrl: './resources/app/components/users/add-edit-user.view.html',
	      controller: 'ModalInstanceCtrl',
	      controllerAs: 'vm',
	      resolve: {
	          items: function () {
	           // return vm.itemsTOEditModel;
	        	  return row;
	          },
	          titlename: function () {
		    	  return titlename;
		    	  }
	        }
		});
		modalInstance.result.then(function (userInfo) {
		     vm.userAddUpdateInfo = userInfo;
		     console.log('User info in user control :'+ JSON.stringify(vm.userAddUpdateInfo));
		    }, function () {
		     // $log.info('Modal dismissed at: ' + new Date());
		    	console.log('Modal dismissed at: ' + new Date());
		    });
	}
	
	vm.DeleteSelectedUsers = function(){
		console.log('Delete all is clicked');
	}
	vm.openUserModel=function(){
	//	vm.titleContent = "Create User";
	//	$("#addUser").modal();
	}
	vm.displayDeleteUserModal = function(row){
		//console.log('row data delete: '+ JSON.stringify(row));
		//$window.confirm("Do you want to delete role " + JSON.stringify(row) + "?")
		//alert('row data delete: '+ JSON.stringify(row));
		console.log('opening Delete pop up');
		//vm.itemsTOEditModel = [row.strUserName,row.strPassword,row.strEmailId];
		var modalInstance = $uibModal.open({
		
		  templateUrl: './resources/app/components/users/delete-user.view.html',
	      controller: 'DeleteUserModalInstanceCtrl',
	      controllerAs: 'vm',
	      resolve: {
	          items: function () {
	           // return vm.itemsTOEditModel;
	        	  return row.strUserName;
	          }	          
	        }
		});
		modalInstance.result.then(function () {
		     //vm.userAddUpdateInfo = userInfo;
		     //console.log('User info in user control :'+ JSON.stringify(vm.userAddUpdateInfo));
			console.log('Delete model');
		    }, function () {
		     // $log.info('Modal dismissed at: ' + new Date());
		    	console.log('Modal dismissed at: ' + new Date());
		    });
	}
	vm.linkButtons = 
		'<div class="ui-grid-cell-contents"><a class="CustomIconaTag" title="Edit User"><i class="fa fa-edit iconLink" data-toggle="modal" ng-click="grid.appScope.editUserDetails(row.entity,\'Edit User\')"></i></a>'+
		  ' <a class="CustomIconaTag"  title="Delete User"><i class="fa fa-trash-o iconLink" data-toggle="modal" ng-click="grid.appScope.displayDeleteUserModal(row.entity)"></i></a>'
			+  ' <a class="CustomIconaTag"  title="Reset Password"><i class="fa fa-refresh iconLink" data-toggle="modal"></i></a></div>';
	
	vm.data = [{
		  "UserName": "test",
		  "Email": "test2",
		  "ProjectAssigned": "test3",
		  "RoleAssigned":"test"
		}, {
		  "UserName": "Biju",
		  "Email": "Biju_nair03@infosys.com",
		  "ProjectAssigned": "test2,test3,test4"
		}, {
		  "UserName": "test",
		  "Email": "test2",
		  "ProjectAssigned": "test3"
		}, {
		  "UserName": "test",
		  "Email": "test2",
		  "ProjectAssigned": "test3"
		}, {
		  "UserName": "test",
		  "Email": "test2",
		  "ProjectAssigned": "test3"
		}, {
		  "UserName": "test",
		  "Email": "test2",
		  "ProjectAssigned": "test3"
		}, {
		  "UserName": "test",
		  "Email": "test2",
		  "ProjectAssigned": "test3"
		}];
	vm.gridOptions = {
			
			enableFiltering: false,
			 enableColumnMenus: false,
			 enableRowSelection: true,
			 enableSorting: false,
			 enableSelectAll: true,
			 enableHiding: false,			 
			  onRegisterApi: function(gridApi) {
			  vm.gridApi = gridApi;
			  vm.gridApi.grid.registerRowsProcessor(vm.singleFilter, 200);
			},
			columnDefs: [ {
			  field: 'strUserName',displayName: 'User name'},
			  {field: 'strEmailId',displayName: 'Email'},
			  {field: 'ProjectAssigned',displayName: 'Project assigned'},
			  {field: 'RoleAssigned',displayName: 'Role assigned'}, 
			//{field: 'Reset password',displayName: 'Reset password', enableSorting: false,enableHiding: false},
			  {name: 'Actions',displayName: 'Actions',cellTemplate: vm.linkButtons}
			]};
		vm.gridOptions.appScopeProvider = vm;
	/* $http.get('https://cdn.rawgit.com/angular-ui/ui-grid.info/gh-pages/data/500_complex.json')
	    .success(function(data) {
	      $scope.gridOptions.data = data;
	      $scope.gridOptions.data[0].age = -5;

	      data.forEach( function addDates( row, index ){
	        row.mixedDate = new Date();
	        row.mixedDate.setDate(today.getDate() + ( index % 14 ) );
	        row.gender = row.gender==='male' ? '1' : '2';
	      });
	    }); */
	    
	
			vm.filter = function() {
			vm.gridApi.grid.refresh();
			};
		
			vm.singleFilter = function(renderableRows) {
			var matcher = new RegExp(vm.filterValue);
			renderableRows.forEach(function(row) {
			  var match = false;
			  ['strUserName', 'strEmailId'].forEach(function(field) {
			    
			    if (row.entity[field] && row.entity[field].match(matcher)) {
			      match = true;
			    }
			  });
			  if (!match) {
			    row.visible = false;
			  }
			});
			return renderableRows;
			};
	/*-------------------------------*/
		
}
angular.module('UserModule').controller('ModalInstanceCtrl', function ($uibModalInstance,items,titlename,dataService) {
	
	var vm = this;
	console.log(items);
	vm.titlename = titlename;
	vm.availableRoles=[];
	function getAllRoles() {
		
        dataService.restCall('index/roles', 'GET').then(function (response) {
        	//console.log('response data123'+ response);
        	
        	vm.availableRoles= response;
        
        	console.log('haii roles'+ JSON.stringify(vm.availableRoles));
        }, function (error) {
        	console.log(error);
        });
    }
	(function () {

        getAllRoles();
        console.log('getroles');
    } ());
	vm.userInfo = {};
	//vm.userInfo.availableRoles = ['Red','Green','Blue','Yellow','Magenta','Maroon','Umbra','Turquoise'];
	
	  vm.userInfo.selectedRoles = [];
	vm.items = items;
	
	/*vm.userInfo.userName = vm.items[0];
			vm.userInfo.password =  vm.items[1];
			vm.userInfo.confirmPassword =  vm.items[1];
			vm.userInfo.emailID =  vm.items[2];*/
	//vm.userInfo.userName = row.strUserName;
	//	vm.userInfo.password = row.strPassword;
	//	vm.userInfo.confirmPassword = row.strPassword;
	//	vm.userInfo.emailID = row.strEmailId;
	vm.userInfo.userName = vm.items.strUserName;
	vm.userInfo.password =  vm.items.strPassword;
	vm.userInfo.confirmPassword =  vm.items.strPassword;
	vm.userInfo.emailID =  vm.items.strEmailId;
			vm.saveUserDetails =  function() {
				console.log('vm.userinfo : '+ JSON.stringify(vm.userInfo));
				  $uibModalInstance.close(vm.userInfo);
				
			}	
			
	  vm.cancel = function () {
		  console.log('selected roles ' + JSON.stringify(vm.userInfo.selectedRoles));
	    $uibModalInstance.dismiss('cancel');
	  };
	  
	  
	  /*
	   * -----------------Date Picker-----------------------------*/
	  vm.datePickerPopup = {
			    opened: false
			  };
	  vm.openDatePicker = function() {
		    vm.datePickerPopup.opened = true;
		  };
		  vm.dateOptions = {
				    
				    formatYear: 'yy',
				    maxDate: new Date(2020, 5, 22),
				    minDate: new Date(),
				    startingDay: 1
				  };
	});
angular.module('UserModule').controller('DeleteUserModalInstanceCtrl', function ($uibModalInstance,items) {
	var vm = this;
	console.log(items);
	
	vm.userToDelete = items;
	
	/*vm.userInfo.userName = vm.items[0];
			vm.userInfo.password =  vm.items[1];
			vm.userInfo.confirmPassword =  vm.items[1];
			vm.userInfo.emailID =  vm.items[2];*/
	//vm.userInfo.userName = row.strUserName;
	//	vm.userInfo.password = row.strPassword;
	//	vm.userInfo.confirmPassword = row.strPassword;
	//	vm.userInfo.emailID = row.strEmailId;
	
			vm.deleteUserYes =  function() {
				//console.log('vm.userinfo : '+ JSON.stringify(vm.userInfo));
				  $uibModalInstance.close();
			}	
			
	  vm.deleteUserNo = function () {
	    $uibModalInstance.dismiss('cancel');
	  };
	  
	  
	 
	});
