package com.infosys.itaw.login.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.infosys.itaw.login.business.service.LoginService;
import com.infosys.itaw.user.persistence.dto.UserDTO;

import itawexception.ItawException;

@RestController
public class LoginController {

	@Autowired
	LoginService loginService;
	
	 @RequestMapping(value="/login/{username}/{password}", method = RequestMethod.GET )
		public int verifyLogin(@PathVariable("username") String username,@PathVariable("password") String password) throws ItawException{
		 UserDTO user=new UserDTO();
		 user.setStrUserName(username);
		 user.setStrPassword(password);
		return loginService.intValidateUser(user);	
		 
			}
	 
	 @RequestMapping("/indexas")
	 public String index() {
		   return "index";
	   }
}
