/* ====================================================================
 *
 * � 2010 Infosys Technologies Limited, Bangalore, India. All rights reserved. 
 * Infosys Test Automation Accelerator * Version: 6.7

 * Except for any open source software components embedded in this Infosys proprietary software program 
 * ("Program"), this Program is protected by copyright laws, international treaties and other pending or existing intellectual
 * property rights in India, the United States 
 * and other countries. Except as expressly permitted, any unauthorized reproduction, storage, transmission in any form 
 * or by any means (including without limitation electronic, mechanical, printing, photocopying, recording or otherwise),
 * or any distribution of this Program, or any portion of it, may result in severe civil and criminal penalties, and will be prosecuted to the maximum extent possible under the law.

 ======================================================================*/
package com.infosys.itaw.user.persistence.dto;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.xml.bind.annotation.XmlRootElement;
import java.sql.Timestamp;
import java.util.Date;

/**
 * Form class for user module
 * @author Neha
 */
//@Entity
//@XmlRootElement(name="user")
public class UserDTO {
	
public UserDTO(){}
	
	/**
	 * Declaratioon of the class variables
	 */
	int iUserId;
	String strUserName; 
	

	String strPassword;
	String strEmailId;
	Date dateCreation;
	int intTemp;
	int failedLoginAttempts;
	Date dateFailedLogin;
	Date endDate;
	public Date getEndDate() {
		return endDate;
	}

	public void setEndDate(Date endDate) {
		this.endDate = endDate;
	}

	/**
	 * @return the failedLoginAttempts
	 */
	public int getFailedLoginAttempts() {
		return failedLoginAttempts;
	}

	/**
	 * @param failedLoginAttempts the failedLoginAttempts to set
	 */
	public void setFailedLoginAttempts(int failedLoginAttempts) {
		this.failedLoginAttempts = failedLoginAttempts;
	}

	/**
	 * @return the dateFailedLogin
	 */
	public Date getDateFailedLogin() {
		return dateFailedLogin;
	}

	/**
	 * @param dateFailedLogin the dateFailedLogin to set
	 */
	public void setDateFailedLogin(Date dateFailedLogin) {
		this.dateFailedLogin = dateFailedLogin;
	}

	public Date getDateCreation() {
		return dateCreation;
	}

	public void setDateCreation(Date dateCreation) {
		this.dateCreation = dateCreation;
	}

	public int getIntTemp() {
		return intTemp;
	}

	public void setIntTemp(int intTemp) {
		this.intTemp = intTemp;
	}

	/**
	 * gets user id
	 * @return iUserId the user id
	 */
	public int getiUserId() {
		return iUserId;
	}

	public void setiUserId(int iUserId) {
		this.iUserId = iUserId;
	}
	
	/**
	 * gets email id
	 * @return strEmailId the email id
	 */
	public String getStrEmailId() {
		return strEmailId;
	}
	
	/**
	 * sets email id
	 * @param strEmailId the email id
	 */
	public void setStrEmailId(String strEmailId) {
		this.strEmailId = strEmailId;
	}
	
	/**
	 * gets password
	 * @return strPassword the password
	 */
	public String getStrPassword() {
		return strPassword;
	}
	
	/**
	 * sets password
	 * @param strPassword the password
	 */
	public void setStrPassword(String strPassword) {
		this.strPassword = strPassword;
	}
	
	/**
	 * gets user name
	 * @return strUserName the user name
	 */
	public String getStrUserName() {
		return strUserName;
	}
	
	/**
	 * sets user name
	 * @param strUserName the user name
	 */
	public void setStrUserName(String strUserName) {
		this.strUserName = strUserName;
	}





}