// project.controller.js
angular
    .module('ProjectModule',['ui.grid','ui.grid.selection'])
    .controller('ProjectController', ProjectController);


function ProjectController(dataService, $uibModal) { 
	var vm=this;
	vm.titleContent = "Create Project";
	
	vm.projectList=[];
	vm.allUsers=[];
	vm.allPlatforms=[];
	vm.projectInfo ={};    
	

		function getProjects() {
        dataService.restCall('index/projects', 'GET').then(function (response) {
           //console.log(response);
		   vm.projectList= response;
        	if(response.length != 0){
        	vm.gridOptions.data = vm.projectList;}
        	}, function (error) {
        	console.log(error);
        });
    }	
	(function () {

        //function: get list of Roles
		getProjects();
        console.log('getproject');
       
    } ());
	vm.saveProjectDetails = function(){
		
		
		
	}
	vm.AddProjectDetails = function (titlename) {
		console.log('opening pop up Add');
		var modalInstance = $uibModal.open({
		
		  templateUrl: './resources/app/components/projects/add-edit-project.view.html',
	      controller: 'ModalInstanceCtrl',
	      controllerAs: 'vm',
	      resolve: {
	          items: function () {
	            return vm.itemsTOEditModel;
	          },
	          titlename: function () {
		    	  return titlename;
		    	  }
	        }
		});
		}
	
	vm.editProjectDetails = function(row,titlename){

		console.log('opening Edit pop up');
		vm.itemsTOEditModel = [row.strProjectName,row.strDescription,row.strProjectCode,row.strProjectManager,row.strProjectManageremail];
		var modalInstance = $uibModal.open({
		
		  templateUrl: './resources/app/components/projects/add-edit-project.view.html',
	      controller: 'ProjectModalInstanceCtrl',
	      controllerAs: 'vm',
	      resolve: {
	          items: function () {
	            return vm.itemsTOEditModel;
	          },
	          titlename: function () {
		    	  return titlename;
		    	  }
	        }
		});
	}
	vm.openProjectModel=function(){
	//	vm.titleContent = "Create Project";
	//	$("#addRole").modal();
	}
	vm.displayDeleteProjectModal = function(row){
		//console.log('row data delete: '+ JSON.stringify(row));
		//$window.confirm("Do you want to delete role " + JSON.stringify(row) + "?")
		alert('row data delete: '+ JSON.stringify(row));
	}
	vm.linkButtons = 
		'<div class="ui-grid-cell-contents"><a class="CustomIconaTag" title="Edit Project"><i class="fa fa-edit iconLink" data-toggle="modal" ng-click="grid.appScope.editProjectDetails(row.entity,\'Edit Project\')"></i></a>'+
		  ' <a class="CustomIconaTag"  title="Delete Project"><i class="fa fa-trash-o iconLink" data-toggle="modal" ng-click="grid.appScope.displayDeleteProjectModal(row.entity)"></i></a>'
			+  ' <a class="CustomIconaTag"  title="Reset Password"><i class="fa fa-refresh iconLink" data-toggle="modal"></i></a></div>';
	
		vm.data = [{
		  "ProjectName": "test1",
		  "Description": "test2",
		  "ProjectCode": "test",
		  "ProjectManager": "test2",
		  "ManagerEmail": "test3",
		  "UserDetail": "op",
		  "ApplicationPlatformDetails": "op",
		  "Edit": "op"
		
		}, {
			  "ProjectName": "test2",
			  "Description": "test2",
			  "ProjectCode": "test",
			  "ProjectManager": "test2",
			  "ManagerEmail": "test3",
			  "UserDetail": "op",
			  "ApplicationPlatformDetails": "op",
			  "Edit": "op"
			 
		}, {
			  "ProjectName": "test3",
			  "Description": "test2",
			  "ProjectCode": "test",
			  "ProjectManager": "test2",
			  "ManagerEmail": "test3",
			  "UserDetail": "op",
			  "ApplicationPlatformDetails": "op",
			  "Edit": "op"
			  
		}, {
			  "ProjectName": "test4",
			  "Description": "test2",
			  "ProjectCode": "test",
			  "ProjectManager": "test2",
			  "ManagerEmail": "test3",
			  "UserDetail": "op",
			  "ApplicationPlatformDetails": "op",
			  "Edit": "op"
			  
		}, {
			  "ProjectName": "test5",
			  "Description": "test2",
			  "ProjectCode": "test",
			  "ProjectManager": "test2",
			  "ManagerEmail": "test3",
			  "UserDetail": "op",
			  "ApplicationPlatformDetails": "op",
			  "Edit": "op"
			
		}, {
			  "ProjectName": "test6",
			  "Description": "test2",
			  "ProjectCode": "test",
			  "ProjectManager": "test2",
			  "ManagerEmail": "test3",
			  "UserDetail": "op",
			  "ApplicationPlatformDetails": "op",
			  "Edit": "op"
			
		}, {
			  "ProjectName": "BijuDemo",
			  "Description": "test2",
			  "ProjectCode": "test",
			  "ProjectManager": "test2",
			  "ManagerEmail": "test3",
			  "UserDetail": "op",
			  "ApplicationPlatformDetails": "op",
			  "Edit": "op"
			  
		}];
vm.gridOptions = {
			data:vm.data,
			enableFiltering: false,
			 enableColumnMenus: false,
			 enableRowSelection: true,
			 enableSorting: false,
			 enableSelectAll: true,
			 enableHiding: false,			 
			  onRegisterApi: function(gridApi) {
			  vm.gridApi = gridApi;
			  vm.gridApi.grid.registerRowsProcessor(vm.singleFilter, 200);
			},
			columnDefs: [{
				 field: 'strProjectName',displayName: 'Project Name'
				}, {
				 field: 'strDescription',displayName: 'Description'
				}, {
				 field: 'strProjectCode',displayName: 'Project Code'
				}, {
				 field: 'strProjectManager',displayName: 'Project Manager'
				}, {
				 field: 'strManagerEmail',displayName: 'Manager Email'
				}, {
				 field: 'strUserDetail',displayName: 'Users'
				}, {
				 field: 'strApplicationPlatformDetails',displayName: 'Platform'
				},
				{name: 'Actions',displayName: 'Actions',cellTemplate: vm.linkButtons}
				]	
			};
	
	
		vm.gridOptions.appScopeProvider = vm;
	    
	
			vm.filter = function() {
			vm.gridApi.grid.refresh();
			};
		
			vm.singleFilter = function(renderableRows) {
			var matcher = new RegExp(vm.filterValue);
			renderableRows.forEach(function(row) {
			  var match = false;
			  ['strProjectName','strProjectCode'].forEach(function(field) {
			    
			    if (row.entity[field] && row.entity[field].match(matcher)) {
			      match = true;
			    }
			  });
			  if (!match) {
			    row.visible = false;
			  }
			});
			return renderableRows;
			};
	/*-------------------------------*/
		
}
angular.module('ProjectModule').controller('ProjectModalInstanceCtrl', function ($uibModalInstance,items,titlename) {
	var vm = this;
	console.log(items);
	vm.titlename = titlename;
	
	vm.projectInfo = {};
	vm.projectInfo.availableUsers = ['Red','Green','Blue','Yellow','Magenta','Maroon','Umbra','Turquoise'];
	vm.projectInfo.availablePlatform = ['Red','Green','Blue','Yellow','Magenta','Maroon','Umbra','Turquoise'];
	  vm.projectInfo.selectedUser = [];
	    vm.projectInfo.selectedPlatform = [];
	vm.items = items;
	
	vm.projectInfo.projectName = vm.items[0];
			vm.projectInfo.description =  vm.items[1];
			vm.projectInfo.projectCode =  vm.items[2];
			
			vm.projectInfo.projectManager =  vm.items[3];
			vm.projectInfo.projectManagerEmail =  vm.items[4];
			//vm.ProjectInfo.selectedUser =  vm.items[5];
			//vm.ProjectInfo.selectedPlatform =  vm.items[6];
	  vm.cancel = function () {
	    $uibModalInstance.dismiss('cancel');
	  }; 
	  
	
	});
